Linux shell script not executing completely as desktop shortcut

2.4k Views Asked by At

I'm looking to create a shell script to open a set of applications whenever I start my workday. I found a couple posts like this which seem to be what I'm looking for. The problem is, the script doesn't work when I double-click on it.

If I start the script from Terminal, it executes completely, but I don't want to always have to call this from Terminal, I want to double-click a shortcut. If I add a "sleep 1" to the end, it works most the time, but the problem here is 1 second is not always enough time to execute everything. Also, it just feels very imprecise. Sure, I could say "sleep 10" and be done with it, but, as a developer, this feels like a hack solution.

Here is my current script, I intend to add my applications to this list over time, but this will be sufficient for now:

#!/bin/bash
skype &
/opt/google/chrome/google-chrome &
geany &
mysql-workbench &

So the question is: how can I ensure everything starts but not leave the temporary terminal window open longer than it needs to be?

In case it matters, to create this script I simply saved a .sh file to the desktop and checked "Allow executing file as program" in the file properties.

4

There are 4 best solutions below

1
On

** UPDATE **

(notice I added an ampersand & to the end of my answer below)

You could do a one-liner. The following will run all commands sequentially, one-at-a-time, each one runs only if/when the previous one ends. The command-line statement terminates if AND WHEN any of the individual commands BETWEEN the & fail.

(skype && /opt/google/chrome/google-chrome && geany && mysql-workbench) && echo "Success!" || echo "fail" &
2
On

Try preceding each command with nohup:

#!/bin/bash
nohup skype &
nohup /opt/google/chrome/google-chrome &
nohup geany &
nohup mysql-workbench &

Better yet, use a loop:

#!/bin/bash

apps="skype /opt/google/chrome/google-chrome geany mysql-workbench"

for app in $apps; do
  nohup $app &
done

If any errors occur, check nohup.out for messages.

4
On

I think the reason of this problem is too early closed I/O files (ttys, most likely). You can try redirecting all I/O (stdin, stdout, stderr), for example:

skype < /dev/null > /dev/null 2 > /dev/null &

Something like this should also work:

#!/bin/sh
{
  skype &
  /opt/google/chrome/google-chrome &
  geany &
  mysql-workbench &
} < /dev/null > /dev/null 2 > /dev/null &

EDIT:

I can reproduce it on Ubuntu 12.04. It seems terminal program when closing kills all processes in it's pgroup. Tried with:

/usr/bin/gnome-terminal -x /bin/sh -c ./test.sh
xterm -e ./test.sh`

result is the same - without sleep programs don't show up. It seems terminal, when script finishes sends SIGHUP to pgroup of the shell script. You can see it by runing any of above programs via strace -f. At the listing end there should be kill(PID,SIGHUP) with very big PID number as argument - actually it is negative number, so SIGHUP is sent to all processes in pgroup.

I would assume many X11 ignore SIGHUP. The problem is SIGHUP is sent/received before they change default behaviour. With sleep You are giving some time to change SIGHUP handling.

I've tried disown (bash builtin), but it didn't help (SIGHUP to pgroup is sent from terminal, not shell).

EDIT:

One possible solution would be to make script.desktop file (You can use some existing .desktop file as template, on Ubuntu these are located at /usr/share/applications) and start Your script from this file. It seems even X11 programs, which don't ignore SIGHUP (xclock) are normaly started this way.

1
On
  1. Firstly, you seem to have a TRAILING ampersand (&) ... this might be causing some issues.

  2. Secondly, you could do something like below to ensure that you only exit the shell (i.e. execution) upon success:

    #!/bin/bash
    
    skype & /opt/google/chrome/google-chrome & geany & mysql-workbench
    
    if [ $? -eq 0 ]
    then
      echo "Successfully completed operation (launched files, etc...)"
    
      #use if you don't want to see anything/be notified if successful
      ## 'exit 0' will exit TERMINAL, therefore the SCRIPT AS WELL
      ## indicating to the shell that there was NO ERROR (success)
      #exit 1  
      exit 0    
    
      ## 'return 0' will allow the "successful" message to be written 
      ## to the command-line and then keep the terminal open, if you
      ## want confirmation of success. The SCRIPT then exits and 
      ## control returns to terminal, but it will not be forced close.
      return 0
    
    else
      echo "Operation failed!" >&2
      ## 'exit 1' will exit the TERMINAL, and therefore the SCRIPT AS 
      ## WELL, indicating an ERROR to the shell 
      #exit 1  
    
      ## 'return 1' will exit the SCRIPT only (but not the terminal) and 
      ## will indicate an ERROR to the shell
      return 1
    
    fi